Attribute VB_Name = "Module1"
' API call for Shell
Public Declare Function ShellExecute _
                            Lib "shell32.dll" _
                            Alias "ShellExecuteA" ( _
                            ByVal hwnd As Long, _
                            ByVal lpOperation As String, _
                            ByVal lpFile As String, _
                            ByVal lpParameters As String, _
                            ByVal lpDirectory As String, _
                            ByVal nShowCmd As Long) _
                            As Long


' API call for registering windows messages
Private Declare Function RegisterWindowMessage Lib "user32" Alias _
  "RegisterWindowMessageA" (ByVal lpString As String) As Long
  
' API call to set the function which receives windows messages
Public Declare Function SetWindowLongApi Lib "user32" _
     Alias "SetWindowLongA" _
    (ByVal hwnd As Long, ByVal nIndex As Long, _
     ByVal dwNewLong As Long) As Long
     
' API call to window functions
Private Declare Function CallWindowProc Lib _
      "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc _
      As Long, ByVal hwnd As Long, ByVal msg As Long, ByVal _
       wParam As Long, ByVal lParam As Long) As Long

Public Const GWL_WNDPROC = (-4)
Public Const SW_HIDE = 0

Public wm_Nova_FileSaved As Long
Public wm_Nova_PrintError As Long

'create the NovaPdfOptions object
Public m_NovaOptions As New NovaPdfOptions90


Public oldHandler As Long

Sub Main()
    ' Registering the messages send by the print in order to listen for them
    wm_Nova_FileSaved = RegisterWindowMessage(MSG_NOVAPDF2_FILESAVED)
    wm_Nova_PrintError = RegisterWindowMessage(MSG_NOVAPDF2_PRINTERROR)
    Form1.Show
End Sub

' Sub that will handle the windows messages
Public Function VB_WindowProc(ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
    ' For the registered messages perform specific tasks
    If wMsg = wm_Nova_FileSaved Then
        OnNovaPDFFileSaved wParam, lParam
        Exit Function
    End If
    If wMsg = wm_Nova_PrintError Then
        OnNovaPDFPrintError wParam, lParam
        Exit Function
    End If
    
    ' For other messages just send them via normal (old) handling process
    VB_WindowProc = CallWindowProc(oldHandler, hwnd, wMsg, wParam, lParam)
End Function


Private Sub OnNovaPDFFileSaved(wParam As Long, lParam As Long)
    m_NovaOptions.UnRegisterEventWindow
    m_NovaOptions.RestoreDefaultPrinter
End Sub

Private Sub OnNovaPDFPrintError(wParam As Long, lParam As Long)
    Select Case wParam
        Case ERROR_MSG_TEMP_FILE:
            MsgBox "Error saving temporary file on printer server", vbOKOnly, "novaPDF"
        Case ERROR_MSG_LIC_INFO:
            MsgBox "Error reading license information", vbOKOnly, "novaPDF"
        Case ERROR_MSG_SAVE_PDF:
            MsgBox "Error saving PDF file", vbOKOnly, "novaPDF"
        Case ERROR_MSG_JOB_CANCELED:
            MsgBox "Print job was canceled", vbOKOnly, "novaPDF"
    End Select
    m_NovaOptions.UnRegisterEventWindow
    m_NovaOptions.RestoreDefaultPrinter
End Sub
